"""LCM type definitions
This file automatically generated by lcm.
DO NOT MODIFY BY HAND!!!!
"""

try:
    import cStringIO.StringIO as BytesIO
except ImportError:
    from io import BytesIO
import struct

class altitude_t(object):
    __slots__ = ["value", "units"]

    def __init__(self):
        self.value = 0.0
        self.units = ""

    def encode(self):
        buf = BytesIO()
        buf.write(altitude_t._get_packed_fingerprint())
        self._encode_one(buf)
        return buf.getvalue()

    def _encode_one(self, buf):
        buf.write(struct.pack(">d", self.value))
        __units_encoded = self.units.encode('utf-8')
        buf.write(struct.pack('>I', len(__units_encoded)+1))
        buf.write(__units_encoded)
        buf.write(b"\0")

    def decode(data):
        if hasattr(data, 'read'):
            buf = data
        else:
            buf = BytesIO(data)
        if buf.read(8) != altitude_t._get_packed_fingerprint():
            raise ValueError("Decode error")
        return altitude_t._decode_one(buf)
    decode = staticmethod(decode)

    def _decode_one(buf):
        self = altitude_t()
        self.value = struct.unpack(">d", buf.read(8))[0]
        __units_len = struct.unpack('>I', buf.read(4))[0]
        self.units = buf.read(__units_len)[:-1].decode('utf-8', 'replace')
        return self
    _decode_one = staticmethod(_decode_one)

    _hash = None
    def _get_hash_recursive(parents):
        if altitude_t in parents: return 0
        tmphash = (0x2aa9500c5d36e404) & 0xffffffffffffffff
        tmphash  = (((tmphash<<1)&0xffffffffffffffff)  + (tmphash>>63)) & 0xffffffffffffffff
        return tmphash
    _get_hash_recursive = staticmethod(_get_hash_recursive)
    _packed_fingerprint = None

    def _get_packed_fingerprint():
        if altitude_t._packed_fingerprint is None:
            altitude_t._packed_fingerprint = struct.pack(">Q", altitude_t._get_hash_recursive([]))
        return altitude_t._packed_fingerprint
    _get_packed_fingerprint = staticmethod(_get_packed_fingerprint)

